Index: serefpolicy-contrib-20140730/gnome.te
===================================================================
--- serefpolicy-contrib-20140730.orig/gnome.te
+++ serefpolicy-contrib-20140730/gnome.te
@@ -1,18 +1,37 @@
-policy_module(gnome, 2.4.1)
+policy_module(gnome, 2.3.0)
 
 ##############################
 #
 # Declarations
 #
 
-attribute gkeyringd_domain;
 attribute gnomedomain;
+attribute gnome_home_type;
+attribute gkeyringd_domain;
 attribute_role gconfd_roles;
 
 type gconf_etc_t;
 files_config_file(gconf_etc_t)
 
-type gconf_home_t;
+type data_home_t, gnome_home_type;
+userdom_user_home_content(data_home_t)
+
+type config_home_t, gnome_home_type;
+userdom_user_home_content(config_home_t)
+
+type cache_home_t, gnome_home_type;
+userdom_user_home_content(cache_home_t)
+
+type gstreamer_home_t, gnome_home_type;
+userdom_user_home_content(gstreamer_home_t)
+
+type dbus_home_t, gnome_home_type;
+userdom_user_home_content(dbus_home_t)
+
+type icc_data_home_t, gnome_home_type;
+userdom_user_home_content(icc_data_home_t)
+
+type gconf_home_t, gnome_home_type;
 typealias gconf_home_t alias { user_gconf_home_t staff_gconf_home_t sysadm_gconf_home_t };
 typealias gconf_home_t alias { auditadm_gconf_home_t secadm_gconf_home_t };
 typealias gconf_home_t alias unconfined_gconf_home_t;
@@ -31,111 +50,225 @@ typealias gconfd_t alias { auditadm_gcon
 userdom_user_application_domain(gconfd_t, gconfd_exec_t)
 role gconfd_roles types gconfd_t;
 
-type gnome_home_t;
+type gnome_home_t, gnome_home_type;
 typealias gnome_home_t alias { user_gnome_home_t staff_gnome_home_t sysadm_gnome_home_t };
 typealias gnome_home_t alias { auditadm_gnome_home_t secadm_gnome_home_t };
 typealias gnome_home_t alias unconfined_gnome_home_t;
 userdom_user_home_content(gnome_home_t)
 
+# type KDE /usr/share/config files
+type config_usr_t;
+files_type(config_usr_t)
+
 type gkeyringd_exec_t;
-application_executable_file(gkeyringd_exec_t)
+corecmd_executable_file(gkeyringd_exec_t)
+
+type gkeyringd_gnome_home_t, gnome_home_type;
+userdom_user_home_content(gkeyringd_gnome_home_t)
+
+type gkeyringd_tmp_t;
+userdom_user_tmp_content(gkeyringd_tmp_t)
 
-type gnome_keyring_home_t;
-userdom_user_home_content(gnome_keyring_home_t)
+type gconfdefaultsm_t;
+type gconfdefaultsm_exec_t;
+init_daemon_domain(gconfdefaultsm_t, gconfdefaultsm_exec_t)
 
-type gnome_keyring_tmp_t;
-userdom_user_tmp_file(gnome_keyring_tmp_t)
+type gnomesystemmm_t;
+type gnomesystemmm_exec_t;
+init_daemon_domain(gnomesystemmm_t, gnomesystemmm_exec_t)
 
 ##############################
 #
-# Common local Policy
+# Local Policy
 #
 
-allow gnomedomain self:process { getsched signal };
-allow gnomedomain self:fifo_file rw_fifo_file_perms;
+allow gconfd_t self:process getsched;
+allow gconfd_t self:fifo_file rw_fifo_file_perms;
 
-dev_read_urand(gnomedomain)
+manage_dirs_pattern(gconfd_t, gconf_home_t, gconf_home_t)
+manage_files_pattern(gconfd_t, gconf_home_t, gconf_home_t)
+userdom_user_home_dir_filetrans(gconfd_t, gconf_home_t, dir)
 
-domain_use_interactive_fds(gnomedomain)
+manage_dirs_pattern(gconfd_t, gconf_tmp_t, gconf_tmp_t)
+manage_files_pattern(gconfd_t, gconf_tmp_t, gconf_tmp_t)
+userdom_user_tmp_filetrans(gconfd_t, gconf_tmp_t, { dir file })
 
-files_read_etc_files(gnomedomain)
+allow gconfd_t gconf_etc_t:dir list_dir_perms;
+read_files_pattern(gconfd_t, gconf_etc_t, gconf_etc_t)
 
-miscfiles_read_localization(gnomedomain)
+dev_read_urand(gconfd_t)
 
-logging_send_syslog_msg(gnomedomain)
 
-userdom_use_user_terminals(gnomedomain)
+
+logging_send_syslog_msg(gconfd_t)
+
+userdom_manage_user_tmp_sockets(gconfd_t)
+userdom_manage_user_tmp_dirs(gconfd_t)
+userdom_tmp_filetrans_user_tmp(gconfd_t, dir)
 
 optional_policy(`
-	xserver_rw_xdm_pipes(gnomedomain)
-	xserver_use_xdm_fds(gnomedomain)
+	nscd_dontaudit_search_pid(gconfd_t)
 ')
 
-##############################
+optional_policy(`
+	xserver_use_xdm_fds(gconfd_t)
+	xserver_rw_xdm_pipes(gconfd_t)
+')
+
+#######################################
 #
-# Conf daemon local Policy
+# gconf-defaults-mechanisms local policy
 #
 
-allow gconfd_t gconf_etc_t:dir list_dir_perms;
-read_files_pattern(gconfd_t, gconf_etc_t, gconf_etc_t)
+allow gconfdefaultsm_t self:capability { dac_override sys_nice };
+allow gconfdefaultsm_t self:process getsched;
+allow gconfdefaultsm_t self:fifo_file rw_fifo_file_perms;
 
-manage_dirs_pattern(gconfd_t, gconf_home_t, gconf_home_t)
-manage_files_pattern(gconfd_t, gconf_home_t, gconf_home_t)
-userdom_user_home_dir_filetrans(gconfd_t, gconf_home_t, dir)
+corecmd_search_bin(gconfdefaultsm_t)
 
-manage_dirs_pattern(gconfd_t, gconf_tmp_t, gconf_tmp_t)
-manage_files_pattern(gconfd_t, gconf_tmp_t, gconf_tmp_t)
-userdom_user_tmp_filetrans(gconfd_t, gconf_tmp_t, { dir file })
+auth_read_passwd(gconfdefaultsm_t)
 
-userdom_manage_user_tmp_dirs(gconfd_t)
-userdom_tmp_filetrans_user_tmp(gconfd_t, dir)
+gnome_manage_gconf_home_files(gconfdefaultsm_t)
+gnome_manage_gconf_config(gconfdefaultsm_t)
+
+userdom_read_all_users_state(gconfdefaultsm_t)
+userdom_search_user_home_dirs(gconfdefaultsm_t)
+
+userdom_dontaudit_search_admin_dir(gconfdefaultsm_t)
 
 optional_policy(`
-	dbus_all_session_domain(gconfd_t, gconfd_exec_t)
+	consolekit_dbus_chat(gconfdefaultsm_t)
+')
 
-	dbus_system_bus_client(gconfd_t)
+optional_policy(`
+	dbus_system_domain(gconfdefaultsm_t, gconfdefaultsm_exec_t)
 ')
 
 optional_policy(`
-	nscd_dontaudit_search_pid(gconfd_t)
+	nscd_dontaudit_search_pid(gconfdefaultsm_t)
 ')
 
-##############################
+optional_policy(`
+	policykit_domtrans_auth(gconfdefaultsm_t)
+	policykit_dbus_chat(gconfdefaultsm_t)
+	policykit_read_lib(gconfdefaultsm_t)
+	policykit_read_reload(gconfdefaultsm_t)
+')
+
+userdom_home_manager(gconfdefaultsm_t)
+
+#######################################
+#
+# gnome-system-monitor-mechanisms local policy
+#
+
+allow gnomesystemmm_t self:capability { sys_admin sys_nice };
+allow gnomesystemmm_t self:fifo_file rw_fifo_file_perms;
+
+rw_files_pattern(gnomesystemmm_t, config_usr_t, config_usr_t)
+
+kernel_read_system_state(gnomesystemmm_t)
+
+corecmd_search_bin(gnomesystemmm_t)
+
+domain_kill_all_domains(gnomesystemmm_t)
+domain_search_all_domains_state(gnomesystemmm_t)
+domain_setpriority_all_domains(gnomesystemmm_t)
+domain_signal_all_domains(gnomesystemmm_t)
+domain_sigstop_all_domains(gnomesystemmm_t)
+
+fs_getattr_xattr_fs(gnomesystemmm_t)
+
+auth_read_passwd(gnomesystemmm_t)
+
+logging_send_syslog_msg(gnomesystemmm_t)
+
+userdom_read_all_users_state(gnomesystemmm_t)
+userdom_dontaudit_search_admin_dir(gnomesystemmm_t)
+
+optional_policy(`
+	consolekit_dbus_chat(gnomesystemmm_t)
+')
+
+optional_policy(`
+	dbus_system_domain(gnomesystemmm_t, gnomesystemmm_exec_t)
+')
+
+optional_policy(`
+ 	gnome_manage_home_config(gnomesystemmm_t)
+')
+
+optional_policy(`
+	nscd_dontaudit_search_pid(gnomesystemmm_t)
+')
+
+optional_policy(`
+	policykit_dbus_chat(gnomesystemmm_t)
+	policykit_domtrans_auth(gnomesystemmm_t)
+	policykit_read_lib(gnomesystemmm_t)
+	policykit_read_reload(gnomesystemmm_t)
+')
+
+######################################
 #
-# Keyring-daemon local policy
+# gnome-keyring-daemon local policy
 #
 
 allow gkeyringd_domain self:capability ipc_lock;
-allow gkeyringd_domain self:process { getcap setcap };
+allow gkeyringd_domain self:process { getcap getsched setcap signal };
+allow gkeyringd_domain self:fifo_file rw_fifo_file_perms;
 allow gkeyringd_domain self:unix_stream_socket { connectto accept listen };
 
-allow gkeyringd_domain gnome_home_t:dir create_dir_perms;
-gnome_home_filetrans_gnome_home(gkeyringd_domain, dir, ".gnome2")
+manage_files_pattern(gkeyringd_domain, config_home_t, config_home_t)
 
-manage_dirs_pattern(gkeyringd_domain, gnome_keyring_home_t, gnome_keyring_home_t)
-manage_files_pattern(gkeyringd_domain, gnome_keyring_home_t, gnome_keyring_home_t)
-gnome_home_filetrans(gkeyringd_domain, gnome_keyring_home_t, dir, "keyrings")
-
-manage_dirs_pattern(gkeyringd_domain, gnome_keyring_tmp_t, gnome_keyring_tmp_t)
-manage_sock_files_pattern(gkeyringd_domain, gnome_keyring_tmp_t, gnome_keyring_tmp_t)
-files_tmp_filetrans(gkeyringd_domain, gnome_keyring_tmp_t, dir)
+manage_dirs_pattern(gkeyringd_domain, gkeyringd_gnome_home_t, gkeyringd_gnome_home_t)
+manage_files_pattern(gkeyringd_domain, gkeyringd_gnome_home_t, gkeyringd_gnome_home_t)
+allow gkeyringd_domain data_home_t:dir create_dir_perms;
+allow gkeyringd_domain gconf_home_t:dir create_dir_perms;
+filetrans_pattern(gkeyringd_domain, gconf_home_t, data_home_t, dir, "share")
+filetrans_pattern(gkeyringd_domain, gnome_home_t, gkeyringd_gnome_home_t, dir, "keyrings")
+filetrans_pattern(gkeyringd_domain, data_home_t, gkeyringd_gnome_home_t, dir, "keyrings")
+
+manage_dirs_pattern(gkeyringd_domain, gkeyringd_tmp_t, gkeyringd_tmp_t)
+manage_sock_files_pattern(gkeyringd_domain, gkeyringd_tmp_t, gkeyringd_tmp_t)
+files_tmp_filetrans(gkeyringd_domain, gkeyringd_tmp_t, dir)
+fs_tmpfs_filetrans(gkeyringd_domain, gkeyringd_tmp_t, dir)
+userdom_user_tmp_filetrans(gkeyringd_domain, gkeyringd_tmp_t, { sock_file dir })
 
-kernel_read_system_state(gkeyringd_domain)
 kernel_read_crypto_sysctls(gkeyringd_domain)
 
+corecmd_search_bin(gkeyringd_domain)
+
 dev_read_rand(gkeyringd_domain)
+dev_read_urand(gkeyringd_domain)
 dev_read_sysfs(gkeyringd_domain)
 
-files_read_usr_files(gkeyringd_domain)
+# for nscd?
+files_search_pids(gkeyringd_domain)
 
-fs_getattr_all_fs(gkeyringd_domain)
+fs_getattr_xattr_fs(gkeyringd_domain)
+fs_getattr_tmpfs(gkeyringd_domain)
 
-selinux_getattr_fs(gkeyringd_domain)
+userdom_user_home_dir_filetrans(gkeyringd_domain, gconf_home_t, dir, ".local")
 
 optional_policy(`
-	ssh_read_user_home_files(gkeyringd_domain)
+	xserver_append_xdm_home_files(gkeyringd_domain)
+	xserver_read_xdm_home_files(gkeyringd_domain)
+	xserver_use_xdm_fds(gkeyringd_domain)
+')
+
+optional_policy(`
+    gnome_create_home_config_dirs(gkeyringd_domain)
+	gnome_read_home_config(gkeyringd_domain)
+    gnome_manage_generic_cache_files(gkeyringd_domain)
+	gnome_manage_cache_home_dir(gkeyringd_domain)
+	gnome_manage_generic_cache_sockets(gkeyringd_domain)
 ')
 
 optional_policy(`
-	telepathy_mission_control_read_state(gkeyringd_domain)
+	ssh_read_user_home_files(gkeyringd_domain)
 ')
+
+domain_use_interactive_fds(gnomedomain)
+
+userdom_use_inherited_user_terminals(gnomedomain)
Index: serefpolicy-contrib-20140730/gpg.fc
===================================================================
--- serefpolicy-contrib-20140730.orig/gpg.fc
+++ serefpolicy-contrib-20140730/gpg.fc
@@ -1,10 +1,14 @@
-HOME_DIR/\.gnupg(/.+)?	gen_context(system_u:object_r:gpg_secret_t,s0)
-HOME_DIR/\.gnupg/log-socket	-s	gen_context(system_u:object_r:gpg_agent_tmp_t,s0)
+HOME_DIR/\.gnupg(/.+)?		gen_context(system_u:object_r:gpg_secret_t,s0)
+HOME_DIR/\.gnupg/log-socket	gen_context(system_u:object_r:gpg_agent_tmp_t,s0)
+
+/etc/mail/spamassassin/sa-update-keys(/.*)?	gen_context(system_u:object_r:gpg_secret_t,s0)
+
+/root/\.gnupg(/.+)?		gen_context(system_u:object_r:gpg_secret_t,s0)
 
 /usr/bin/gpg(2)?	--	gen_context(system_u:object_r:gpg_exec_t,s0)
-/usr/bin/gpgsm	--	gen_context(system_u:object_r:gpg_exec_t,s0)
+/usr/bin/gpgsm		--	gen_context(system_u:object_r:gpg_exec_t,s0)
 /usr/bin/gpg-agent	--	gen_context(system_u:object_r:gpg_agent_exec_t,s0)
 /usr/bin/pinentry.*	--	gen_context(system_u:object_r:pinentry_exec_t,s0)
 
 /usr/lib/gnupg/.*	--	gen_context(system_u:object_r:gpg_exec_t,s0)
-/usr/lib/gnupg/gpgkeys.*	--	gen_context(system_u:object_r:gpg_helper_exec_t,s0)
+/usr/lib/gnupg/gpgkeys.* --	gen_context(system_u:object_r:gpg_helper_exec_t,s0)
Index: serefpolicy-contrib-20140730/gpg.if
===================================================================
--- serefpolicy-contrib-20140730.orig/gpg.if
+++ serefpolicy-contrib-20140730/gpg.if
@@ -2,57 +2,79 @@
 
 ############################################################
 ## <summary>
-##	Role access for gpg.
+##	Role access for gpg
 ## </summary>
 ## <param name="role">
 ##	<summary>
-##	Role allowed access.
+##	Role allowed access
 ##	</summary>
 ## </param>
 ## <param name="domain">
 ##	<summary>
-##	User domain for the role.
+##	User domain for the role
 ##	</summary>
 ## </param>
 #
 interface(`gpg_role',`
 	gen_require(`
-		attribute_role gpg_roles, gpg_agent_roles, gpg_helper_roles, gpg_pinentry_roles;
-		type gpg_t, gpg_exec_t, gpg_agent_t;
-		type gpg_agent_exec_t, gpg_agent_tmp_t, gpg_helper_t;
-		type gpg_pinentry_t, gpg_pinentry_tmp_t, gpg_secret_t;
+        attribute_role gpg_roles, gpg_agent_roles, gpg_helper_roles, gpg_pinentry_roles;
+		type gpg_t, gpg_exec_t;
+		type gpg_agent_t, gpg_agent_exec_t;
+		type gpg_agent_tmp_t;
+		type gpg_helper_t, gpg_pinentry_t;
+		type gpg_pinentry_tmp_t;
 	')
 
-	roleattribute $1 gpg_roles;
-	roleattribute $1 gpg_agent_roles;
-	roleattribute $1 gpg_helper_roles;
-	roleattribute $1 gpg_pinentry_roles;
+    roleattribute $1 gpg_roles;
+    roleattribute $1 gpg_agent_roles;
+    roleattribute $1 gpg_helper_roles;
+    roleattribute $1 gpg_pinentry_roles;
 
+	# transition from the userdomain to the derived domain
 	domtrans_pattern($2, gpg_exec_t, gpg_t)
-	domtrans_pattern($2, gpg_agent_exec_t, gpg_agent_t)
 
-	allow $2 { gpg_t gpg_agent_t gpg_helper_t gpg_pinentry_t }:process { ptrace signal_perms };
-	ps_process_pattern($2, { gpg_t gpg_agent_t gpg_helper_t gpg_pinentry_t })
+	# allow ps to show gpg
+	ps_process_pattern($2, gpg_t)
+	allow $2 gpg_t:process { signull sigstop signal sigkill };
 
-	allow gpg_pinentry_t $2:process signull;
+	# communicate with the user
 	allow gpg_helper_t $2:fd use;
-	allow { gpg_t gpg_agent_t gpg_helper_t gpg_pinentry_t } $2:fifo_file { read write };
+	allow gpg_helper_t $2:fifo_file write;
+
+	# allow ps to show gpg-agent
+	ps_process_pattern($2, gpg_agent_t)
 
-	allow $2 { gpg_agent_tmp_t gpg_secret_t }:dir { manage_dir_perms relabel_dir_perms };
-	allow $2 { gpg_agent_tmp_t gpg_secret_t }:file { manage_file_perms relabel_file_perms };
-	allow $2 gpg_secret_t:lnk_file { manage_lnk_file_perms relabel_lnk_file_perms };
-	allow $2 { gpg_agent_tmp_t gpg_pinentry_tmp_t gpg_secret_t }:sock_file { manage_sock_file_perms relabel_sock_file_perms };
-	filetrans_pattern($2, gpg_secret_t, gpg_agent_tmp_t, sock_file, "log-socket")
-	userdom_user_home_dir_filetrans($2, gpg_secret_t, dir, ".gnupg")
+	# Allow the user shell to signal the gpg-agent program.
+	allow $2 gpg_agent_t:process { signal sigkill };
+
+	manage_dirs_pattern($2, gpg_agent_tmp_t, gpg_agent_tmp_t)
+	manage_files_pattern($2, gpg_agent_tmp_t, gpg_agent_tmp_t)
+	manage_sock_files_pattern($2, gpg_agent_tmp_t, gpg_agent_tmp_t)
+	files_tmp_filetrans(gpg_agent_t, gpg_agent_tmp_t, { file sock_file dir })
+
+	# Transition from the user domain to the agent domain.
+	domtrans_pattern($2, gpg_agent_exec_t, gpg_agent_t)
+
+	manage_sock_files_pattern($2, gpg_pinentry_tmp_t, gpg_pinentry_tmp_t)
+	relabel_sock_files_pattern($2, gpg_pinentry_tmp_t, gpg_pinentry_tmp_t)
+
+	allow gpg_pinentry_t $2:fifo_file { read write };
 
 	optional_policy(`
 		gpg_pinentry_dbus_chat($2)
 	')
+
+	allow $2 gpg_agent_t:unix_stream_socket { rw_socket_perms connectto };
+	ifdef(`hide_broken_symptoms',`
+		#Leaked File Descriptors
+		dontaudit gpg_t $2:fifo_file rw_fifo_file_perms;
+		dontaudit gpg_agent_t $2:fifo_file rw_fifo_file_perms;
+	')
 ')
 
 ########################################
 ## <summary>
-##	Execute the gpg in the gpg domain.
+##	Transition to a user gpg domain.
 ## </summary>
 ## <param name="domain">
 ##	<summary>
@@ -65,13 +87,12 @@ interface(`gpg_domtrans',`
 		type gpg_t, gpg_exec_t;
 	')
 
-	corecmd_search_bin($1)
 	domtrans_pattern($1, gpg_exec_t, gpg_t)
 ')
 
-########################################
+######################################
 ## <summary>
-##	Execute the gpg in the caller domain.
+##	Execute gpg in the caller domain.
 ## </summary>
 ## <param name="domain">
 ##	<summary>
@@ -88,76 +109,46 @@ interface(`gpg_exec',`
 	can_exec($1, gpg_exec_t)
 ')
 
-########################################
-## <summary>
-##	Execute gpg in a specified domain.
-## </summary>
-## <desc>
-##	<p>
-##	Execute gpg in a specified domain.
-##	</p>
-##	<p>
-##	No interprocess communication (signals, pipes,
-##	etc.) is provided by this interface since
-##	the domains are not owned by this module.
-##	</p>
-## </desc>
-## <param name="source_domain">
-##	<summary>
-##	Domain allowed to transition.
-##	</summary>
-## </param>
-## <param name="target_domain">
-##	<summary>
-##	Domain to transition to.
-##	</summary>
-## </param>
-#
-interface(`gpg_spec_domtrans',`
-	gen_require(`
-		type gpg_exec_t;
-	')
-
-	corecmd_search_bin($1)
-	domain_auto_trans($1, gpg_exec_t, $2)
-')
-
 ######################################
 ## <summary>
-##	Execute gpg in the gpg web domain.  (Deprecated)
+##  Transition to a gpg web domain.
 ## </summary>
 ## <param name="domain">
-##	<summary>
-##	Domain allowed to transition.
-##	</summary>
+##  <summary>
+##  Domain allowed access.
+##  </summary>
 ## </param>
 #
 interface(`gpg_domtrans_web',`
-	refpolicywarn(`$0($*) has been deprecated.')
+    gen_require(`
+        type gpg_web_t, gpg_exec_t;
+    ')
+
+    domtrans_pattern($1, gpg_exec_t, gpg_web_t)
 ')
 
 ######################################
 ## <summary>
-##	Make gpg executable files an
-##	entrypoint for the specified domain.
+##  Make gpg an entrypoint for
+##  the specified domain.
 ## </summary>
 ## <param name="domain">
-##	<summary>
-##	The domain for which gpg_exec_t is an entrypoint.
-##	</summary>
+##  <summary>
+##  The domain for which cifs_t is an entrypoint.
+##  </summary>
 ## </param>
 #
 interface(`gpg_entry_type',`
-	gen_require(`
-		type gpg_exec_t;
-	')
+    gen_require(`
+        type gpg_exec_t;
+    ')
 
-	domain_entry_file($1, gpg_exec_t)
+    domain_entry_file($1, gpg_exec_t)
 ')
 
 ########################################
 ## <summary>
-##	Send generic signals to gpg.
+##	Send generic signals to user gpg processes.
 ## </summary>
 ## <param name="domain">
 ##	<summary>
@@ -175,7 +166,7 @@ interface(`gpg_signal',`
 
 ########################################
 ## <summary>
-##	Read and write gpg agent pipes.
+##	Read and write GPG agent pipes.
 ## </summary>
 ## <param name="domain">
 ##	<summary>
@@ -184,6 +175,7 @@ interface(`gpg_signal',`
 ## </param>
 #
 interface(`gpg_rw_agent_pipes',`
+	# Just wants read/write could this be a leak?
 	gen_require(`
 		type gpg_agent_t;
 	')
@@ -193,7 +185,8 @@ interface(`gpg_rw_agent_pipes',`
 
 ########################################
 ## <summary>
-##	Connect to gpg agent socket
+##	Send messages to and from GPG
+##	Pinentry over DBUS.
 ## </summary>
 ## <param name="domain">
 ##	<summary>
@@ -201,18 +194,19 @@ interface(`gpg_rw_agent_pipes',`
 ##	</summary>
 ## </param>
 #
-interface(`gpg_stream_connect_agent',`
+interface(`gpg_pinentry_dbus_chat',`
 	gen_require(`
-		type gpg_agent_t, gpg_agent_tmp_t;
+		type gpg_pinentry_t;
+		class dbus send_msg;
 	')
 
-	stream_connect_pattern($1, gpg_agent_tmp_t, gpg_agent_tmp_t, gpg_agent_t)
+	allow $1 gpg_pinentry_t:dbus send_msg;
+	allow gpg_pinentry_t $1:dbus send_msg;
 ')
 
 ########################################
 ## <summary>
-##	Send messages to and from gpg
-##	pinentry over DBUS.
+##	List Gnu Privacy Guard user secrets.
 ## </summary>
 ## <param name="domain">
 ##	<summary>
@@ -220,31 +214,47 @@ interface(`gpg_stream_connect_agent',`
 ##	</summary>
 ## </param>
 #
-interface(`gpg_pinentry_dbus_chat',`
+interface(`gpg_list_user_secrets',`
 	gen_require(`
-		type gpg_pinentry_t;
-		class dbus send_msg;
+		type gpg_secret_t;
 	')
 
-	allow $1 gpg_pinentry_t:dbus send_msg;
-	allow gpg_pinentry_t $1:dbus send_msg;
+	list_dirs_pattern($1, gpg_secret_t, gpg_secret_t)
+	userdom_search_user_home_dirs($1)
 ')
+###########################
+## <summary>
+##	Allow to manage gpg named home content
+## </summary>
+## <param name="domain">
+##	<summary>
+##      Domain allowed access.
+##	</summary>
+## </param>
+#
+interface(`gpg_manage_home_content',`
+	gen_require(`
+		type gpg_secret_t;
+	')
 
+	manage_files_pattern($1, gpg_secret_t, gpg_secret_t)
+	manage_dirs_pattern($1, gpg_secret_t, gpg_secret_t)
+	userdom_user_home_dir_filetrans($1, gpg_secret_t, dir, ".gnupg")
+')
 ########################################
 ## <summary>
-##	List gpg user secrets.
+##	Transition to gpg named home content
 ## </summary>
 ## <param name="domain">
 ##	<summary>
-##	Domain allowed access.
+##      Domain allowed access.
 ##	</summary>
 ## </param>
 #
-interface(`gpg_list_user_secrets',`
+interface(`gpg_filetrans_home_content',`
 	gen_require(`
 		type gpg_secret_t;
 	')
 
-	list_dirs_pattern($1, gpg_secret_t, gpg_secret_t)
-	userdom_search_user_home_dirs($1)
+	userdom_user_home_dir_filetrans($1, gpg_secret_t, dir, ".gnupg")
 ')
